import hashlib

# Hash Bucket Algos/Designs
class Url_Codec:
    algorithms = {'md5': hashlib.md5}
    
    def __init__(self):
        self.data = {}
    
    def hasher(self, msg: str, algorithm: str = 'md5') -> str:
        try:
            hashing = self.algorithms[algorithm]()
        except:
            return False
        
        
        hashing.update(bytes(msg, 'utf-8'))
        
        self.data[(string_hash := hashing.hexdigest())] = msg

        return string_hash

    def enqueue(self, key, value, option: str = 'renew'):
        if option == 'encode':
            return self.hasher(key)
        else:
            try:
                return self.data[key]
            except:
                return False
    
    def encode(self, longUrl: str) -> str:
        return self.enqueue(longUrl, None, option='encode')

    def decode(self, shortUrl: str) -> str:
        return self.enqueue(shortUrl, None)
        
if __name__ == "__main__":
    Input = 'https://google.com/hello-world/'
    res = ''

    codec = Url_Codec()
    encoded = codec.encode(Input)
    print(encoded)
    print(codec.decode(encoded))
